//DeplacerBlocs_201f.js
// 30.01.15 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Dplace des blocs

//Bas sur "Layout anpassen.jsx" par Gerald Singelmann, 
//une copie traduite de "AdjustLayout.jsx" (CS3), fourni par Adobe,
//extension et traduction par Hans Haesler

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester s'il y a un document ouvert contenant des blocs
if (app.documents.length != 0) {
	if (app.documents[0].pageItems.length == 0) {
		alert ("Ce document ne contient pas de blocs.", "Attention", true);
		exit();
	}
}
else {
	alert ("Il n'y a pas de document ouvert.", "Attention", true);
	exit();
}

// le document au premier plan
curDoc = app.documents[0];

// appeler la fonction qui lit les rglages enregistrs
var allPrefs  = getPrefs();
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	var evenX   = prefVal[0]*1;
	var evenY   = prefVal[1]*1;
	var oddX    = prefVal[2]*1;
	var oddY    = prefVal[3]*1;
	var ignVal1 = prefVal[4];
	if (ignVal1 == "true") { lckFrm = true; }
	else { lckFrm = false; }
	var ignVal2 = prefVal[5];
	if (ignVal2 == "true") { lckLay = true; }
	else { lckLay = false; }
	var ignVal3  = prefVal[6];
	if (ignVal3 == "true") { invLay = true; }
	else { invLay = false; }
}
else {
	// lorsque le fichier des prfrences ne peut pas tre trouv, 
	// utiliser les valeurs par dfaut suivants
	var evenX  = 0;
	var evenY  = 0;
	var oddX   = 0;
	var oddY   = 0;
	var lckFrm = true;
	var lckLay = true;
	var invLay = true;
}

// mmoriser les units de mesure
var curXUnits = (curDoc.viewPreferences.horizontalMeasurementUnits)*1;
var curYUnits = (curDoc.viewPreferences.verticalMeasurementUnits)*1;

// mmoriser la valeur de l'option de numrotation des pages actuelle...
var oldPageNumbering = app.generalPreferences.pageNumbering;
// ... et appliquer la numrotation des sections
app.generalPreferences.pageNumbering = PageNumberingOptions.section;

// supprimer des dialogues ventuellement prsents dans la mmoire
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}
// prparer le dialogue
var pageNames = getPageNames();
var labelWidth = 78;
var aDialog = app.dialogs.add({name:"Dplacer les blocs"});
with (aDialog.dialogColumns.add()) {
	with (borderPanels.add()) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				with (dialogColumns.add()) {
					staticTexts.add({staticLabel:"De la page:", minWidth:labelWidth-10});
				}
				with (dialogColumns.add()) {
					var startPageDropdown = dropdowns.add({stringList:pageNames, selectedIndex:0});
				}
			}
			with (dialogRows.add()) {
				with (dialogColumns.add()) {
					staticTexts.add({staticLabel:" la page:", minWidth:labelWidth-10});
				}
				with (dialogColumns.add()) {
					var endPageDropdown = dropdowns.add({stringList:pageNames, selectedIndex:pageNames.length-1});
				}
			}
		}
	}
	with (borderPanels.add()) {
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Aux page paires"});
					staticTexts.add({staticLabel:" "});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Horizontal:", minWidth:labelWidth});
					var evenXField = measurementEditboxes.add({editValue:evenX, editUnits:curXUnits});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Vertical:", minWidth:labelWidth});
					var evenYField = measurementEditboxes.add({editValue:evenY, editUnits:curYUnits});
				}
			}
		}
	}
	with (borderPanels.add()) {
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Aux pages impaires"});
					staticTexts.add({staticLabel:" "});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Horizontal:", minWidth:labelWidth});
					var oddXField = measurementEditboxes.add({editValue:oddX, editUnits:curXUnits});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Vertical:", minWidth:labelWidth});
					var oddYField = measurementEditboxes.add({editValue:oddY, editUnits:curYUnits});
				}
			}
		}
	}
	with (dialogRows.add()) {
		staticTexts.add({staticLabel:"Tenir compte des options coches:"});
	}
	with (borderPanels.add()) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" "});
				with (dialogColumns.add()) {
					var lckFrmField = checkboxControls.add({staticLabel:"blocs verrouills",checkedState:lckFrm});
					var lckLayField = checkboxControls.add({staticLabel:"calques verrouills",checkedState:lckLay});
					var invLayField = checkboxControls.add({staticLabel:"calques invisibles",checkedState:invLay});
				}
			}
		}
	}
}
// afficher le dialogue
if (aDialog.show() == true) {
	var startPageName = pageNames[startPageDropdown.selectedIndex];
	var endPageName = pageNames[endPageDropdown.selectedIndex];
	var doLckFrm = lckFrmField.checkedState;
	var doLckLay = lckLayField.checkedState;
	var doInvLay = invLayField.checkedState;
	var evenX = evenXField.editValue;
	var evenY = evenYField.editValue;
	var oddX  = oddXField.editValue;
	var oddY  = oddYField.editValue;
	aDialog.destroy();
	// vrifier la saisie
	var okay = false;
	var testList = new Array(evenX, evenY, oddX, oddY);
	for (var t=0; t<4; t++) {
		if (testList[t] != 0) {
			okay = true;
			break;
		}
	}
	if (okay == false) {
		alert ("Les quatre valeurs sont zro.", "Stop", true);
		app.generalPreferences.pageNumbering = oldPageNumbering;
		exit();
	}
	// la liste des rglages...
	var prefsList = new Array(evenX, evenY, oddX, oddY, doLckFrm, doLckLay, doInvLay);
	// ... la convertir en chane de texte...
	var prefString = prefsList.join("\n");
	// ... et l'envoyer  la fonction qui l'crit dans un fichier...
	writeResult(prefString);
	// appeler la fonction qui dverrouille les calques
	if (doLckLay == true) {
		var lockList = unlockLayers();
	}
	// appeler la fonction qui affiche les calques invisibles
	if (doInvLay == true) {
		var visiList = showLayers();
	}
	// ... et  la fonction qui lanc les actions
	adjustPages(evenX, evenY, oddX, oddY, startPageName, endPageName, doLckFrm, doLckLay, doInvLay);
	// verrouiller les calques qui taient verrouills
	if (doLckLay == true) {
		lockLayers(lockList);
	}
	// rendre invisibles les calques qui taient invisibles
	if (doInvLay == true) {
		hideLayers(visiList);
	}
	// appliquer les valeurs d'origine aus rglages
	curDoc.viewPreferences.horizontalMeasurementUnits = curXUnits;
	curDoc.viewPreferences.verticalMeasurementUnits   = curYUnits;
	app.generalPreferences.pageNumbering = oldPageNumbering;
}
else {
	aDialog.destroy();
}


////////////////////////////// les fonctions //////////////////////////////////////////////

// la fonction qui prpare les informations ///////////////////////////////////////////////
function getPrefs() {
	var allPrefs = "";
	// lire le fichier contenant les rglages mmoriss
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/DeplacerBlocs201.txt");
	}
	else {
		var f = new File("~/Library/Preferences/DeplacerBlocs201.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// crire le rsultat dans un fichier
function writeResult(curPrefs) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/DeplacerBlocs201.txt");
	}
	else {
		var f = new File("~/Library/Preferences/DeplacerBlocs201.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// dverrouiller les calques //////////////////////////////////////////////////////////////
function unlockLayers() {
	var allLayers = curDoc.layers;
	var nLayers = allLayers.length;
	var lockList = new Array();
	for (var n=0; n<nLayers; n++) {
		var curLayer = allLayers[n];
		if (curLayer.locked == true) {
			curLayer.locked = false;
			lockList.push(true);
		}
		else {
			lockList.push(false);
		}
	}
	return (lockList);
}

// rendre les calques visibles ////////////////////////////////////////////////////////////
function showLayers() {
	var allLayers = curDoc.layers;
	var nLayers = allLayers.length;
	var visiList = new Array();
	for (var n=0; n<nLayers; n++) {
		var curLayer = allLayers[n];
		if (curLayer.visible == false) {
			curLayer.visible = true;
			visiList.push(true);
		}
		else {
			visiList.push(false);
		}
	}
	return (visiList);
}

// cette fonction vrifie quels blocs doivent tre dplacs sur quelles pages /////////////
function adjustPages(evenX, evenY, oddX, oddY, startPageName, endPageName, doLckFrm, doLckLay, doInvLay) {
	// dfinir les units de mesure en points
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.points;
	curDoc.viewPreferences.verticalMeasurementUnits   = MeasurementUnits.points;
	var curPage;
	var startPos = curDoc.pages.item(startPageName).documentOffset-1;
	var endPos   = curDoc.pages.item(endPageName).documentOffset-1;
	// croiser les valeurs quand la page de dpart est plus grande que celle de fin
	if (startPos < endPos) {
		var startVal = startPos;
		var stopVal  = endPos+1;
	}
	else {
		var startVal = endPos;
		var stopVal  = startPos+1;
	}		
	// une boucle  travers les pages slectionnes
	for (var ctr=startVal; ctr<stopVal; ctr++) {
		// die aktuelle Seite
		curPage = curDoc.pages.item(ctr);
		if (((curPage.name)*1)%2 == 0) {
			// un numro de page pair
			adjustPage(curPage, evenX, evenY, doLckFrm, doLckLay, doInvLay);
		}
		else {
			// un numro de page impair
			adjustPage(curPage, oddX, oddY, doLckFrm, doLckLay, doInvLay);
		}
	}
}

// cette fonction adresse la page actuelle ////////////////////////////////////////////////
function adjustPage(curPage, x, y, doLckFrm, doLckLay, doInvLay) {
	var curPageItem, resetItemLock;
	for (var ctr = 0; ctr < curPage.pageItems.length; ctr ++) {
		resetItemLock = false;
		curPageItem = curPage.pageItems.item(ctr);
		if (curPageItem.locked == true) {
			if (doLckFrm == true) {
				curPageItem.locked = false;
				resetItemLock = true;
			}
		}
		if (curPageItem.locked == false && curPageItem.itemLayer.locked == false) {
			if (curPageItem.itemLayer.visible == true) {
				curPageItem.move(undefined, [x, y]);
			}
		}
		if (resetItemLock == true) {
			curPageItem.locked = true;
		}
	}
}

// la fonction qui liste les numros des pages ////////////////////////////////////////////
function getPageNames() {
	var pageNames = new Array;
	// vrifier s'il y des prfixes de section
	var sectPrefs = false;
	var allPrefNames = new Array();
	for (var p=0; p<curDoc.pages.length; p++) {
		var curSect = curDoc.pages[p].appliedSection.name;
		allPrefNames.push(curSect);
	}
	var testString = allPrefNames.join("");
	if (testString.length > 0) {
		sectPrefs = true;
	}
	// liste des numros des pages
	if (sectPrefs == false) {
		pageNames = curDoc.pages.everyItem().name;
	}
	else {
		var pageNames = new Array();
		for (var p=0; p<curDoc.pages.length; p++) {
			var curName = curDoc.pages[p].name;
			pageNames.push(allPrefNames[p] + curName);
		}
	}
	return pageNames;
}

// verrrouiller les calques ///////////////////////////////////////////////////////////////
function lockLayers(lockList) {
	var allLayers = curDoc.layers;
	var nLayers = allLayers.length;
	for (var n=0; n<nLayers; n++) {
		var curLayer = allLayers[n];
		if (lockList[n] == true) {
			curLayer.locked = true;
		}
	}
}

// rendre les calques invisibles //////////////////////////////////////////////////////////
function hideLayers(visiList) {
	var allLayers = curDoc.layers;
	var nLayers = allLayers.length;
	for (var n=0; n<nLayers; n++) {
		var curLayer = allLayers[n];
		if (visiList[n] == true) {
			curLayer.visible = false;
		}
	}
}